declare type ExtractArgs<T> = T extends (...args: infer A) => any ? A : undefined;
declare type ExtractReturn<T> = T extends (...args: any) => infer R ? R : never;
/**
 * Creates a callback from function declaration
 *
 * On call it passes arguments provided as an array in second argument
 */
export declare function useStaticCallback<T extends () => any>(callback: T): () => ExtractReturn<T>;
export declare function useStaticCallback<T extends (...args: any[]) => any>(callback: T, args: ExtractArgs<T>): () => ExtractReturn<T>;
/**
 * Creates a callback using a callback creator
 *
 * Passes arguments provided as an array in second argument to the callback creator
 * and returns the result as a callback
 */
export declare function useStaticCallbackCreator<T extends () => (...args: any[]) => any>(callback: T): ExtractReturn<T>;
export declare function useStaticCallbackCreator<T extends (...args: any[]) => (...args: any[]) => any>(callback: T, args: ExtractArgs<T>): ExtractReturn<T>;
export {};
//# sourceMappingURL=index.d.ts.map